---
title: File and Directory Entries API support in Firefox
slug: Web/API/File_and_Directory_Entries_API/Firefox_support
tags:
  - API
  - Chrome
  - Compatibility
  - File System API
  - File and Directory Entries API
  - Files
  - Firefox
  - Guide
  - Offline
  - Web Compatibility
  - google
  - google chrome
---
<div>{{DefaultAPISidebar("File System API")}}{{Non-standard_header}}</div>

<p>The original File System API was created to let browsers implement support for accessing a sandboxed virtual file system on the user's storage device. Work to standardize the specification was abandoned back in 2012, but by that point, Google Chrome included its own implementation of the API. Over time, a number of popular sites and Web applications came to use it, often without providing any means of falling back to standard APIs or even checking to be sure the API is available before using it. Mozilla instead opted to implement other APIs which can be used to solve many of the same problems, such as <a href="/en-US/docs/Web/API/IndexedDB_API">IndexedDB</a>; see the blog post <a href="https://hacks.mozilla.org/2012/07/why-no-filesystem-api-in-firefox/">Why no FileSystem API in Firefox?</a> for more insights.</p>

<p>This has caused a number of popular web sites not to work properly on browsers other than Chrome. Because of that, an attempt was made to create a spec offering the features of Google's API which consensus could be reached on. The result was the <a href="/en-US/docs/Web/API/File_and_Directory_Entries_API">File and Directory Entries API</a>. This subset of the API provided by Chrome is still not fully specified; however, for web compatibility reasons, it was decided to implement a subset of the API in Firefox; this was introduced in Firefox 50.</p>

<p>This article describes how the Firefox implementation of the File and Directory Entries API differs from other implementations and/or the specification.</p>

<h2 id="Chrome_deviations_from_the_specification">Chrome deviations from the specification</h2>

<p>The largest compatibility issue still remaining is that Chrome is still using older names for many of the interfaces in the API, since they implemented a related but different specification:</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="row">Name in specification</th>
   <th scope="col">Name in Google Chrome</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <th scope="row"><code>FileSystemDirectoryEntry</code></th>
   <td><code>DirectoryEntry</code></td>
  </tr>
  <tr>
   <th scope="row"><code>FileSystemDirectoryEntrySync</code></th>
   <td><code>DirectoryEntrySync</code></td>
  </tr>
  <tr>
   <th scope="row"><code>FileSystemDirectoryReader</code></th>
   <td><code>DirectoryReader</code></td>
  </tr>
  <tr>
   <th scope="row"><code>FileSystemDirectoryReaderSync</code></th>
   <td><code>DirectoryReaderSync</code></td>
  </tr>
  <tr>
   <th scope="row"><code>FileSystemEntry</code></th>
   <td><code>Entry</code></td>
  </tr>
  <tr>
   <th scope="row"><code>FileSystemEntrySync</code></th>
   <td><code>EntrySync</code></td>
  </tr>
  <tr>
   <th scope="row"><code>FileSystemFileEntry</code></th>
   <td><code>FileEntry</code></td>
  </tr>
  <tr>
   <th scope="row"><code>FileSystemFileEntrySync</code></th>
   <td><code>FileEntrySync</code></td>
  </tr>
 </tbody>
</table>

<p>Be sure to account for this in your code by allowing for both names. Hopefully Chrome will be updated soon to use the newer names!</p>

<p>To ensure your code will work in both Chrome and other browsers, you can include code similar to the following:</p>

<pre class="brush: js">var FileSystemDirectoryEntry = window.FileSystemDirectoryEntry || window.DirectoryEntry;
var FileSystemEntry = window.FileSystemEntry || window.Entry;
</pre>

<h2 id="Limitations_in_Firefox">Limitations in Firefox</h2>

<p>Next, let's look at limitations of the Firefox implementation of the API. In broad strokes, those limitations can be summarized as follows:</p>

<ul>
 <li>Content scripts can't create file systems or initiate access to a file system. There are only two ways to get access to file system entries at this time:
  <ul>
   <li>The {{HTMLElement("input")}} element, using the {{domxref("HTMLInputElement.webkitEntries")}} property to access an array of {{domxref("FileSystemEntry")}} objects describing file system entries you can then read.</li>
   <li>Using drag and drop by calling the {{domxref("DataTransferItem.getAsEntry()")}} method, which lets you get a {{domxref("FileSystemFileEntry")}} or {{domxref("FileSystemDirectoryEntry")}} for files dropped on a drop zone.</li>
  </ul>
 </li>
 <li>You can't use the <code><a href="/en-US/docs/Web/API/LocalFileSystem#requestFileSystem">LocalFileSystem.requestFileSystem()</a></code> method to get access to a specified local file system.</li>
 <li>The <code><a href="/en-US/docs/Web/API/LocalFileSystem#resolveLocalFileSystemURL">LocalFileSystem.resolveLocalFileSystemURL()</a></code> method isn't implemented.</li>
 <li>Only the asynchronous versions of the interfaces are implemented. Any interfaces with names that end in "<code>Sync"</code> aren't available.</li>
 <li>Firefox only supports reading from files in the file system. You can't write to them. In particular, the {{domxref("FileSystemFileEntry.createWriter()")}} method, used to create a {{domxref("FileWriter")}} to handle writing to a file, is not implemented and will just treturn an error.</li>
 <li>Firefox doesn't support the <code>"filesystem:"</code> URL scheme.</li>
</ul>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/File_and_Directory_Entries_API">File and Directory Entries API</a></li>
 <li><a href="/en-US/docs/Web/API/File_and_Directory_Entries_API/Introduction">Introduction to the File and Directory Entries API</a></li>
 <li>Latest but still early specification for the <a href="https://wicg.github.io/entries-api/">File and Directory Entries API</a>.</li>
 <li>Original specification for the <a href="https://dev.w3.org/2009/dap/file-system/file-dir-sys.html">File API: Directories and System</a> (often called the "FileSystem API"); Google Chrome was the only browser to implement this <strong>abandoned</strong> API.</li>
</ul>
